# Largest Contentful Paint change in Chrome 116 to better handle animated content.

Starting around Chrome 116, we're making two changes to the way that LCP handles
animated images and videos. In both cases, Chrome will count the time that the
first full frame is presented as the timestamp for the candidate.

# Videos

Videos have previously been ignored for LCP, unless they have a poster image.
With this change, a video element can become an LCP candidate, exactly like an
image. If it is used as a candidate, then the associated timestamp will be the
time that the first video frame is presented on screen.

# Animated images

Animated images (animated GIFs and PNGs) were previously not considered as LCP
candidates until they were fully loaded. For large files, this could be long
after the video has been playing on screen. This change counts the time that the
first frame of the animation is displayed, if the image becomes an LCP
candidate.

## How does this affect a site's metrics?
Pages with large auto-playing videos should start seeing that video used as the
LCP element. LCP scores may improve or regress on those pages, depending on what
element is currently being chosen as LCP.

Pages with large animated images will likely see LCP scores improve, as the
image will be reported with an earlier timestamp than before.

## When were users affected?
This change was launched to Chrome users starting on roughly 2023-08-22, to be
rolled out to existing Chrome 116+ installs over a 14 day period.
